<?php

/**
 * CLTracker_Settings 
 * 
 * @since 1.0.0
 * 
 */

 class CLTracker_Settings {

	public static function general_section_callback() {
		?>
		<p style="max-width: 49em"><?php _e( 'Once you&rsquo;ve saved your App Id, You can able to send ecommerce events to Customerlabs CDP', 'cltracker' ); ?></p>
		<?php
    }
    
	public static function app_id_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[app_id]';
	?>
			<input class="regular-text ltr" type="text" name="<?php echo esc_attr( $name ); ?>" id="app_id" value="<?php echo esc_attr( $settings['app_id'] ); ?>" />
			<p class="description"><?php _e( 'You can find your App Id in Menu > Account Settings > API Token > Account ID.', 'cltracker' ); ?></p>
		<?php

	}

	public static function track_logins_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[track_logins]';
	?>
		<label for="track_logins">
			<input name="<?php echo esc_attr( $name ); ?>" type="checkbox" id="track_logins" value="1" <?php checked( 1, $settings['track_logins'] ); ?>/>
			<?php _e( 'Automatically track events when users log in.', 'cltracker' ); ?>
		</label>
		<p class="description"><?php _e( 'This event will be logged on the subsequent page load after a user logs in.', 'cltracker' ); ?></p>

	<?php

    }

	public static function track_search_made_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[track_search_made]';
	?>
		<label for="track_search_made">
			<input name="<?php echo esc_attr( $name ); ?>" type="checkbox" id="track_search_made" value="1" <?php checked( 1, $settings['track_search_made'] ); ?>/>
			<?php _e( 'Automatically track events when users search on your site.', 'cltracker' ); ?>
		</label>
		<p class="description"><?php _e('This setting will turn on & off the "Search made" event.', 'cltracker' ); ?></p>

	<?php

    }

	public static function ecommerce_section_callback() {
		?>
		<p style="max-width: 49em"><?php _e( 'We&rsquo;ll automatically track the following events if you&rsquo;ve enabled WooCommerce.', 'cltracker' ); ?></p>

		<?php
    }

	public static function track_add_to_cart_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[track_add_to_cart]';
	?>
		<label for="track_add_to_cart">
			<input name="<?php echo esc_attr( $name ); ?>" type="checkbox" id="track_add_to_cart" value="1" <?php checked( 1, $settings['track_add_to_cart'] ); ?> />
			<?php _e( 'Automatically track events when your users click "Add to cart" button.', 'cltracker' ); ?>
		</label>
		<p class="description"><?php _e( 'This setting will turn on & off the "Add to cart" event.', 'cltracker' ); ?></p>

	<?php

	}

	public static function track_remove_from_cart_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[track_remove_from_cart]';
	?>
		<label for="track_remove_from_cart">
			<input name="<?php echo esc_attr( $name ); ?>" type="checkbox" id="track_remove_from_cart" value="1" <?php checked( 1, $settings['track_remove_from_cart'] ); ?> />
			<?php _e( 'Automatically track events when your users click "Remove from cart" button.', 'cltracker' ); ?>
		</label>
		<p class="description"><?php _e( 'This setting will turn on & off the "Remove from cart" event.', 'cltracker' ); ?></p>

	<?php

	}

	public static function track_product_viewed_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[track_product_viewed]';
	?>
		<label for="track_product_viewed">
			<input name="<?php echo esc_attr( $name ); ?>" type="checkbox" id="track_product_viewed" value="1" <?php checked( 1, $settings['track_product_viewed'] ); ?> />
			<?php _e( 'Automatically track events when your users visits the product page.', 'cltracker' ); ?>
		</label>
		<p class="description"><?php _e( 'This setting will turn on & off the "Product viewed" event.', 'cltracker' ); ?></p>

	<?php

	}

	public static function track_category_viewed_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[track_category_viewed]';
	?>
		<label for="track_category_viewed">
			<input name="<?php echo esc_attr( $name ); ?>" type="checkbox" id="track_category_viewed" value="1" <?php checked( 1, $settings['track_category_viewed'] ); ?> />
			<?php _e( 'Automatically track events when your users visits the category page', 'cltracker' ); ?>
		</label>
		<p class="description"><?php _e( 'This setting will turn on & off the "Category viewed" event.', 'cltracker' ); ?></p>

	<?php

	}

	public static function track_purchased_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[track_purchased]';
	?>
		<label for="track_purchased">
			<input name="<?php echo esc_attr( $name ); ?>" type="checkbox" id="track_purchased" value="1" <?php checked( 1, $settings['track_purchased'] ); ?> />
			<?php _e( 'Automatically track events when your users complete successful purchase', 'cltracker' ); ?>
		</label>
		<p class="description"><?php _e( 'This setting will turn on & off the "Purchased" event.', 'cltracker' ); ?></p>

	<?php

	}

	public static function track_checkout_made_callback() {

		$settings = CLTracker_Wordpress::get_instance()->get_settings();
		$name     = CLTracker_Wordpress::get_instance()->get_option_name() . '[track_checkout_made]';
	?>
		<label for="track_purchased">
			<input name="<?php echo esc_attr( $name ); ?>" type="checkbox" id="track_checkout_made" value="1" <?php checked( 1, $settings['track_checkout_made'] ); ?> />
			<?php _e( 'Automatically track events when your users did checkout', 'cltracker' ); ?>
		</label>
		<p class="description"><?php _e( 'This setting will turn on & off the "Checkout made" event.', 'cltracker' ); ?></p>

	<?php

	}
    
    public static function core_validation( $input ) {


		$checkboxes = array(
			'track_logins',
			'track_search_made',
			'track_add_to_cart',
			'track_remove_from_cart',
			'track_product_viewed',
			'track_category_viewed',
			'track_purchased',
			'track_checkout_made',
		);

		foreach ( $checkboxes as $checkbox ) {
			$input[ $checkbox ] = isset( $input[ $checkbox ] ) ? '1' : '0';
		}

		$text_fields = array( 'app_id');

		foreach ( $text_fields as $text ) {
			$input[ $text ] = isset( $input[ $text ] ) ? sanitize_text_field( $input[ $text ] ) : '';
		}

		return apply_filters( 'cltracker_settings_core_validation', $input );
	}

}